# PostProcessStageComposite

#### new Cesium.PostProcessStageComposite(options)
Scene/PostProcessStageComposite.js 76

A collection of `PostProcessStage`s or other post-process composite stages that execute together logically.

All stages are executed in the order of the array. The input texture changes based on the value of `inputPreviousStageTexture`. If `inputPreviousStageTexture` is `true`, the input to each stage is the output texture rendered to by the scene or of the stage that executed before it. If `inputPreviousStageTexture` is `false`, the input texture is the same for each stage in the composite. The input texture is the texture rendered to by the scene or the output texture of the previous stage.

Name | Type | Description
--- | --- | ---
`options` | Object | An object with the following properties:
Name | Type | Default | Description
--- | --- | --- | ---
`stages` | Array |  | An array of `PostProcessStage`s or composites to be executed in order.
`inputPreviousStageTexture` | Boolean | `true` | optional Whether to execute each post-process stage where the input to one stage is the output of the previous. Otherwise, the input to each contained stage is the output of the stage that executed before the composite.
`name` | String | `createGuid()` | optional The unique name of this post-process stage for reference by other composites. If a name is not supplied, a GUID will be generated.
`uniforms` | Object |  | optional An alias to the uniforms of post-process stages.

##### Throws:

- DeveloperError : options.stages.length must be greater than 0.0.

##### Examples:

    // Example 1: separable blur filter
    // The input to blurXDirection is the texture rendered to by the scene or the output of the previous stage.
    // The input to blurYDirection is the texture rendered to by blurXDirection.
    scene.postProcessStages.add(new Cesium.PostProcessStageComposite({
        stages : [blurXDirection, blurYDirection]
    }));

    // Example 2: referencing the output of another post-process stage
    scene.postProcessStages.add(new Cesium.PostProcessStageComposite({
        inputPreviousStageTexture : false,
        stages : [
            // The same as Example 1.
            new Cesium.PostProcessStageComposite({
                inputPreviousStageTexture : true
                stages : [blurXDirection, blurYDirection],
                name : 'blur'
            }),
            // The input texture for this stage is the same input texture to blurXDirection since inputPreviousStageTexture is false
            new Cesium.PostProcessStage({
                fragmentShader : compositeShader,
                uniforms : {
                    blurTexture : 'blur' // The output of the composite with name 'blur' (the texture that blurYDirection rendered to).
                }
            })
        ]
    });

    // Example 3: create a uniform alias
    var uniforms = {};
    Cesium.defineProperties(uniforms, {
        filterSize : {
            get : function() {
                return blurXDirection.uniforms.filterSize;
            },
            set : function(value) {
                blurXDirection.uniforms.filterSize = blurYDirection.uniforms.filterSize = value;
            }
        }
    });
    scene.postProcessStages.add(new Cesium.PostProcessStageComposite({
        stages : [blurXDirection, blurYDirection],
        uniforms : uniforms
    }));

##### See:

- PostProcessStage

### Members

#### enabled : Boolean
Scene/PostProcessStageComposite.js 155

Whether or not to execute this post-process stage when ready.

#### readonly inputPreviousStageTexture : Boolean
Scene/PostProcessStageComposite.js 187

All post-process stages are executed in the order of the array. The input texture changes based on the value of `inputPreviousStageTexture`. If `inputPreviousStageTexture` is `true`, the input to each stage is the output texture rendered to by the scene or of the stage that executed before it. If `inputPreviousStageTexture` is `false`, the input texture is the same for each stage in the composite. The input texture is the texture rendered to by the scene or the output texture of the previous stage.

#### readonly length : Number
Scene/PostProcessStageComposite.js 199

The number of post-process stages in this composite.

#### readonly name : String
Scene/PostProcessStageComposite.js 144

The unique name of this post-process stage for reference by other stages in a PostProcessStageComposite.

#### readonly ready : Boolean
Scene/PostProcessStageComposite.js 125

Determines if this post-process stage is ready to be executed.

#### selected : Array
Scene/PostProcessStageComposite.js 210

The features selected for applying the post-process.

#### uniforms : Object
Scene/PostProcessStageComposite.js 172

An alias to the uniform values of the post-process stages. May be `undefined`; in which case, get each stage to set uniform values.

### Methods

#### destroy()
Scene/PostProcessStageComposite.js 352

Destroys the WebGL resources held by this object. Destroying an object allows for deterministic release of WebGL resources, instead of relying on the garbage collector to destroy this object.

Once an object is destroyed, it should not be used; calling any function other than `isDestroyed` will result in a `DeveloperError` exception. Therefore, assign the return value (`undefined`) to the object as done in the example.

##### Throws:

- DeveloperError : This object was destroyed, i.e., destroy() was called.

##### See:

- PostProcessStageComposite#isDestroyed

#### get(index) → PostProcessStage|PostProcessStageComposite
Scene/PostProcessStageComposite.js 254

Gets the post-process stage at `index`

Name | Type | Description
--- | --- | ---
`index` | Number | The index of the post-process stage or composite.

##### Returns:

The post-process stage or composite at index.

##### Throws:

- DeveloperError : index must be greater than or equal to 0.
- DeveloperError : index must be less than `PostProcessStageComposite#length`.

#### isDestroyed() → Boolean
Scene/PostProcessStageComposite.js 335

Returns true if this object was destroyed; otherwise, false.

If this object was destroyed, it should not be used; calling any function other than `isDestroyed` will result in a `DeveloperError` exception.

##### Returns:

`true` if this object was destroyed; otherwise, `false`.

##### See:

- PostProcessStageComposite#destroy